Skip to navigation

Collect a posted debit memo

View as Markdown

Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information.

This API operation provides an easy way to let the client-side to collect an existing posted debit memo. It supports the following steps:

  1. Apply unapplied credit memos to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied credit memos.
  2. Apply unapplied payments to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied payments.
  3. Process payment to the posted debit memo if there is an open-balance on it.

Restrictions

Since this API will do lots of works, and some of them are resource consuming, we need to restrict the usage of this API by the following conditions:

  1. If the target debit memo gets more than 10 debit memo items, the request will be rejected.
  2. If CreditMemo is specified in applicationOrder, when there are more than 25 credit memos will be used to apply to the debit memo, the request will be rejected.
  3. If CreditMemo is specified in applicationOrder, when there are more than 100 credit memo items will be used to apply to the debit memo, the request will be rejected.
  4. If UnappliedPayment is specified in applicationOrder, when there are more than 25 payments will be used to apply to the debit memo, the request will be rejected.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Path parameters

debitMemoKeystringRequired
The ID or number of a posted debit memo. For example, 8a8082e65b27f6c3015ba419f3c2644e.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
applicationOrderlist of stringsOptional

The priority order to apply credit memos and/or unapplied payments to the debit memo. Possible item values are: CreditMemo, UnappliedPayment.

Note:

  • This field is valid only if the applyCredit field is set to true.
  • If no value is specified for this field, the default priority order is used, [“CreditMemo”, “UnappliedPayment”], to apply credit memos first and then apply unapplied payments.
  • If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is ["CreditMemo"], only credit memos are used to apply the debit memo.
applyCreditbooleanOptionalDefaults to false

Whether to automatically apply credit memos or unapplied payments, or both to the debit memo. If the value is true, the credit memo or unapplied payment, or both will be automatically applied to the debit memo. If no value is specified or the value is false, no action is taken.

collectbooleanOptionalDefaults to false
Indicates if the current request needs to collect payment or not.
paymentobjectOptional

Some detail info that would be used to processed an electronic payment. The info would only effect when collect set to true.

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
appliedCreditMemoslist of objectsOptional
The information about which credit memo applied to the specific debit memo.
appliedPaymentslist of objectsOptional
The information about which payment applied to the specific debit memo.
debitMemoobjectOptional
The information about the debit memo that just collected.
organizationLabelstringOptional

The organization that this object belongs to.

Note: This field is available only when the Multi-Org feature is enabled.

processedPaymentobjectOptional
The information about the payment that newly processed to the debit memo.
successbooleanOptional

Returns true if the request was processed successfully.

Errors

4XX
Client Request Error
500
Internal Server Error